'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by a tool.
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------
Imports Telerik.OpenAccess
Imports WebApplication.Dto
Imports WebApplication.Converters
Imports OpenAccessModel.OpenAccessModel
Imports System
Imports System.Linq
Imports System.Linq.Expressions
Imports System.Collections
Imports System.Collections.Generic
Imports System.Runtime.Serialization
Imports OpenAccessModel

Namespace Assemblers
			
	Public Interface IAssembler(Of TDto, TEntity As Class)
		Function Assemble(ByVal entity As TEntity) As TDto
		Function Assemble(ByVal entity As TEntity, ByVal dto As TDto) As TEntity
	
		Function Assemble(ByVal entityList As IEnumerable(Of TEntity)) As IEnumerable(Of TDto)
		Function Assemble(ByVal dtoList As IEnumerable(Of TDto)) As IEnumerable(Of TEntity)
	End Interface
	
	Public MustInherit Class Assembler(Of TDto, TEntity As Class)
		Implements IAssembler(Of TDto, TEntity)
		Public MustOverride Function Assemble(ByVal domainEntity As TEntity) As TDto Implements IAssembler(Of TDto, TEntity).Assemble
		Public MustOverride Function Assemble(ByVal entity As TEntity, ByVal dto As TDto) As TEntity Implements IAssembler(Of TDto, TEntity).Assemble
	
		Public Sub AssembleNavigational(ByVal entity As TEntity, ByVal dto As TDto)
			Me.AssembleReferences(entity, dto)
	    	Me.AssembleCollections(entity, dto)
	    End Sub
	
	    Public MustOverride Sub AssembleReferences(ByVal entity As TEntity, ByVal dto As TDto)
	    Public MustOverride Sub AssembleCollections(ByVal entity As TEntity, ByVal dto As TDto)
	
	
		Public Overridable Function Assemble(ByVal domainEntityList As IEnumerable(Of TEntity)) As IEnumerable(Of TDto) Implements IAssembler(Of TDto, TEntity).Assemble
			Dim dtos As List(Of TDto) = Activator.CreateInstance(Of List(Of TDto))()
			For Each domainEntity As TEntity In domainEntityList
				dtos.Add(Assemble(domainEntity))
			Next domainEntity
			Return dtos
		End Function
	
		Public Overridable Function Assemble(ByVal dtoList As IEnumerable(Of TDto)) As IEnumerable(Of TEntity) Implements IAssembler(Of TDto, TEntity).Assemble
			Dim domainEntities As List(Of TEntity) = Activator.CreateInstance(Of List(Of TEntity))()
			For Each dto As TDto In dtoList
				domainEntities.Add(Assemble(Nothing, dto))
			Next dto
			Return domainEntities
		End Function
	End Class
	
	
	Public Interface ITerritoryAssembler
		Inherits IAssembler(Of TerritoryDto, Territory)
	
	End Interface
	
	Partial Public Class TerritoryAssemblerBase
		Inherits Assembler(Of TerritoryDto, Territory)
	
		''' <summary>
		''' Invoked after the TerritoryDto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="TerritoryDto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As TerritoryDto)
		End Sub
	
		''' <summary>
		''' Invoked after the Territory instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="Territory"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As Territory)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As Territory, ByVal dto As TerritoryDto) As Territory
			If entity Is Nothing Then
				entity = New Territory()
			End If
	
			entity.TerritoryID = dto.TerritoryID
			entity.TerritoryDescription = dto.TerritoryDescription
			entity.RegionID = dto.RegionID
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As Territory) As  TerritoryDto
			Dim dto As New  TerritoryDto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.TerritoryID = entity.TerritoryID
			dto.TerritoryDescription = entity.TerritoryDescription
			dto.RegionID = entity.RegionID
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As Territory, ByVal dto As TerritoryDto)
			Dim regionAssembler = new RegionAssembler()
			dto.Region = regionAssembler.Assemble(entity.Region)

	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As Territory, ByVal dto As TerritoryDto)
			Dim employeeAssembler = new EmployeeAssembler()

			dto.Employees = new List(Of EmployeeDto)()
			For Each item As Employee In entity.Employees
				Dim dtoItem = employeeAssembler.Assemble(item)
				dto.Employees.Add(dtoItem)
			Next
			

	    End Sub
	End Class
	
	
	Partial Public Class TerritoryAssembler
		Inherits TerritoryAssemblerBase
		Implements ITerritoryAssembler
	
	End Class
	
	Public Interface ISupplierAssembler
		Inherits IAssembler(Of SupplierDto, Supplier)
	
	End Interface
	
	Partial Public Class SupplierAssemblerBase
		Inherits Assembler(Of SupplierDto, Supplier)
	
		''' <summary>
		''' Invoked after the SupplierDto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="SupplierDto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As SupplierDto)
		End Sub
	
		''' <summary>
		''' Invoked after the Supplier instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="Supplier"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As Supplier)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As Supplier, ByVal dto As SupplierDto) As Supplier
			If entity Is Nothing Then
				entity = New Supplier()
			End If
	
			entity.SupplierID = dto.SupplierID
			entity.CompanyName = dto.CompanyName
			entity.ContactName = dto.ContactName
			entity.ContactTitle = dto.ContactTitle
			entity.Address = dto.Address
			entity.City = dto.City
			entity.Region = dto.Region
			entity.PostalCode = dto.PostalCode
			entity.Country = dto.Country
			entity.Phone = dto.Phone
			entity.Fax = dto.Fax
			entity.HomePage = dto.HomePage
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As Supplier) As  SupplierDto
			Dim dto As New  SupplierDto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.SupplierID = entity.SupplierID
			dto.CompanyName = entity.CompanyName
			dto.ContactName = entity.ContactName
			dto.ContactTitle = entity.ContactTitle
			dto.Address = entity.Address
			dto.City = entity.City
			dto.Region = entity.Region
			dto.PostalCode = entity.PostalCode
			dto.Country = entity.Country
			dto.Phone = entity.Phone
			dto.Fax = entity.Fax
			dto.HomePage = entity.HomePage
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As Supplier, ByVal dto As SupplierDto)
	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As Supplier, ByVal dto As SupplierDto)
			Dim productAssembler = new ProductAssembler()

			dto.Products = new List(Of ProductDto)()
			For Each item As Product In entity.Products
				Dim dtoItem = productAssembler.Assemble(item)
				dtoItem.Supplier = dto
				dto.Products.Add(dtoItem)
			Next
			

	    End Sub
	End Class
	
	
	Partial Public Class SupplierAssembler
		Inherits SupplierAssemblerBase
		Implements ISupplierAssembler
	
	End Class
	
	Public Interface IShipperAssembler
		Inherits IAssembler(Of ShipperDto, Shipper)
	
	End Interface
	
	Partial Public Class ShipperAssemblerBase
		Inherits Assembler(Of ShipperDto, Shipper)
	
		''' <summary>
		''' Invoked after the ShipperDto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="ShipperDto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As ShipperDto)
		End Sub
	
		''' <summary>
		''' Invoked after the Shipper instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="Shipper"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As Shipper)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As Shipper, ByVal dto As ShipperDto) As Shipper
			If entity Is Nothing Then
				entity = New Shipper()
			End If
	
			entity.ShipperID = dto.ShipperID
			entity.CompanyName = dto.CompanyName
			entity.Phone = dto.Phone
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As Shipper) As  ShipperDto
			Dim dto As New  ShipperDto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.ShipperID = entity.ShipperID
			dto.CompanyName = entity.CompanyName
			dto.Phone = entity.Phone
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As Shipper, ByVal dto As ShipperDto)
	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As Shipper, ByVal dto As ShipperDto)
			Dim orderAssembler = new OrderAssembler()

			dto.Orders = new List(Of OrderDto)()
			For Each item As Order In entity.Orders
				Dim dtoItem = orderAssembler.Assemble(item)
				dtoItem.Shipper = dto
				dto.Orders.Add(dtoItem)
			Next
			

	    End Sub
	End Class
	
	
	Partial Public Class ShipperAssembler
		Inherits ShipperAssemblerBase
		Implements IShipperAssembler
	
	End Class
	
	Public Interface IRegionAssembler
		Inherits IAssembler(Of RegionDto, Region)
	
	End Interface
	
	Partial Public Class RegionAssemblerBase
		Inherits Assembler(Of RegionDto, Region)
	
		''' <summary>
		''' Invoked after the RegionDto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="RegionDto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As RegionDto)
		End Sub
	
		''' <summary>
		''' Invoked after the Region instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="Region"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As Region)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As Region, ByVal dto As RegionDto) As Region
			If entity Is Nothing Then
				entity = New Region()
			End If
	
			entity.RegionID = dto.RegionID
			entity.RegionDescription = dto.RegionDescription
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As Region) As  RegionDto
			Dim dto As New  RegionDto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.RegionID = entity.RegionID
			dto.RegionDescription = entity.RegionDescription
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As Region, ByVal dto As RegionDto)
	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As Region, ByVal dto As RegionDto)
			Dim territoryAssembler = new TerritoryAssembler()

			dto.Territories = new List(Of TerritoryDto)()
			For Each item As Territory In entity.Territories
				Dim dtoItem = territoryAssembler.Assemble(item)
				dtoItem.Region = dto
				dto.Territories.Add(dtoItem)
			Next
			

	    End Sub
	End Class
	
	
	Partial Public Class RegionAssembler
		Inherits RegionAssemblerBase
		Implements IRegionAssembler
	
	End Class
	
	Public Interface IProductAssembler
		Inherits IAssembler(Of ProductDto, Product)
	
	End Interface
	
	Partial Public Class ProductAssemblerBase
		Inherits Assembler(Of ProductDto, Product)
	
		''' <summary>
		''' Invoked after the ProductDto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="ProductDto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As ProductDto)
		End Sub
	
		''' <summary>
		''' Invoked after the Product instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="Product"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As Product)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As Product, ByVal dto As ProductDto) As Product
			If entity Is Nothing Then
				entity = New Product()
			End If
	
			entity.ProductID = dto.ProductID
			entity.ProductName = dto.ProductName
			entity.SupplierID = dto.SupplierID
			entity.CategoryID = dto.CategoryID
			entity.QuantityPerUnit = dto.QuantityPerUnit
			entity.UnitPrice = dto.UnitPrice
			entity.UnitsInStock = dto.UnitsInStock
			entity.UnitsOnOrder = dto.UnitsOnOrder
			entity.ReorderLevel = dto.ReorderLevel
			entity.Discontinued = dto.Discontinued
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As Product) As  ProductDto
			Dim dto As New  ProductDto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.ProductID = entity.ProductID
			dto.ProductName = entity.ProductName
			dto.SupplierID = entity.SupplierID
			dto.CategoryID = entity.CategoryID
			dto.QuantityPerUnit = entity.QuantityPerUnit
			dto.UnitPrice = entity.UnitPrice
			dto.UnitsInStock = entity.UnitsInStock
			dto.UnitsOnOrder = entity.UnitsOnOrder
			dto.ReorderLevel = entity.ReorderLevel
			dto.Discontinued = entity.Discontinued
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As Product, ByVal dto As ProductDto)
			Dim categoryAssembler = new CategoryAssembler()
			dto.Category = categoryAssembler.Assemble(entity.Category)

			Dim supplierAssembler = new SupplierAssembler()
			dto.Supplier = supplierAssembler.Assemble(entity.Supplier)

	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As Product, ByVal dto As ProductDto)
			Dim orderDetailAssembler = new OrderDetailAssembler()

			dto.OrderDetails = new List(Of OrderDetailDto)()
			For Each item As OrderDetail In entity.OrderDetails
				Dim dtoItem = orderDetailAssembler.Assemble(item)
				dtoItem.Product = dto
				dto.OrderDetails.Add(dtoItem)
			Next
			

	    End Sub
	End Class
	
	
	Partial Public Class ProductAssembler
		Inherits ProductAssemblerBase
		Implements IProductAssembler
	
	End Class
	
	Public Interface IOrderAssembler
		Inherits IAssembler(Of OrderDto, Order)
	
	End Interface
	
	Partial Public Class OrderAssemblerBase
		Inherits Assembler(Of OrderDto, Order)
	
		''' <summary>
		''' Invoked after the OrderDto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="OrderDto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As OrderDto)
		End Sub
	
		''' <summary>
		''' Invoked after the Order instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="Order"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As Order)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As Order, ByVal dto As OrderDto) As Order
			If entity Is Nothing Then
				entity = New Order()
			End If
	
			entity.OrderID = dto.OrderID
			entity.CustomerID = dto.CustomerID
			entity.EmployeeID = dto.EmployeeID
			entity.OrderDate = dto.OrderDate
			entity.RequiredDate = dto.RequiredDate
			entity.ShippedDate = dto.ShippedDate
			entity.ShipVia = dto.ShipVia
			entity.Freight = dto.Freight
			entity.ShipName = dto.ShipName
			entity.ShipAddress = dto.ShipAddress
			entity.ShipCity = dto.ShipCity
			entity.ShipRegion = dto.ShipRegion
			entity.ShipPostalCode = dto.ShipPostalCode
			entity.ShipCountry = dto.ShipCountry
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As Order) As  OrderDto
			Dim dto As New  OrderDto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.OrderID = entity.OrderID
			dto.CustomerID = entity.CustomerID
			dto.EmployeeID = entity.EmployeeID
			dto.OrderDate = entity.OrderDate
			dto.RequiredDate = entity.RequiredDate
			dto.ShippedDate = entity.ShippedDate
			dto.ShipVia = entity.ShipVia
			dto.Freight = entity.Freight
			dto.ShipName = entity.ShipName
			dto.ShipAddress = entity.ShipAddress
			dto.ShipCity = entity.ShipCity
			dto.ShipRegion = entity.ShipRegion
			dto.ShipPostalCode = entity.ShipPostalCode
			dto.ShipCountry = entity.ShipCountry
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As Order, ByVal dto As OrderDto)
			Dim customerAssembler = new CustomerAssembler()
			dto.Customer = customerAssembler.Assemble(entity.Customer)

			Dim employeeAssembler = new EmployeeAssembler()
			dto.Employee = employeeAssembler.Assemble(entity.Employee)

			Dim shipperAssembler = new ShipperAssembler()
			dto.Shipper = shipperAssembler.Assemble(entity.Shipper)

	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As Order, ByVal dto As OrderDto)
	    End Sub
	End Class
	
	
	Partial Public Class OrderAssembler
		Inherits OrderAssemblerBase
		Implements IOrderAssembler
	
	End Class
	
	Public Interface IOrderDetailAssembler
		Inherits IAssembler(Of OrderDetailDto, OrderDetail)
	
	End Interface
	
	Partial Public Class OrderDetailAssemblerBase
		Inherits Assembler(Of OrderDetailDto, OrderDetail)
	
		''' <summary>
		''' Invoked after the OrderDetailDto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="OrderDetailDto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As OrderDetailDto)
		End Sub
	
		''' <summary>
		''' Invoked after the OrderDetail instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="OrderDetail"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As OrderDetail)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As OrderDetail, ByVal dto As OrderDetailDto) As OrderDetail
			If entity Is Nothing Then
				entity = New OrderDetail()
			End If
	
			entity.OrderID = dto.OrderID
			entity.ProductID = dto.ProductID
			entity.UnitPrice = dto.UnitPrice
			entity.Quantity = dto.Quantity
			entity.Discount = dto.Discount
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As OrderDetail) As  OrderDetailDto
			Dim dto As New  OrderDetailDto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.OrderID = entity.OrderID
			dto.ProductID = entity.ProductID
			dto.UnitPrice = entity.UnitPrice
			dto.Quantity = entity.Quantity
			dto.Discount = entity.Discount
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As OrderDetail, ByVal dto As OrderDetailDto)
			Dim productAssembler = new ProductAssembler()
			dto.Product = productAssembler.Assemble(entity.Product)

	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As OrderDetail, ByVal dto As OrderDetailDto)
	    End Sub
	End Class
	
	
	Partial Public Class OrderDetailAssembler
		Inherits OrderDetailAssemblerBase
		Implements IOrderDetailAssembler
	
	End Class
	
	Public Interface IEmployeeAssembler
		Inherits IAssembler(Of EmployeeDto, Employee)
	
	End Interface
	
	Partial Public Class EmployeeAssemblerBase
		Inherits Assembler(Of EmployeeDto, Employee)
	
		''' <summary>
		''' Invoked after the EmployeeDto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="EmployeeDto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As EmployeeDto)
		End Sub
	
		''' <summary>
		''' Invoked after the Employee instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="Employee"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As Employee)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As Employee, ByVal dto As EmployeeDto) As Employee
			If entity Is Nothing Then
				entity = New Employee()
			End If
	
			entity.EmployeeID = dto.EmployeeID
			entity.LastName = dto.LastName
			entity.FirstName = dto.FirstName
			entity.Title = dto.Title
			entity.TitleOfCourtesy = dto.TitleOfCourtesy
			entity.BirthDate = dto.BirthDate
			entity.HireDate = dto.HireDate
			entity.Address = dto.Address
			entity.City = dto.City
			entity.Region = dto.Region
			entity.PostalCode = dto.PostalCode
			entity.Country = dto.Country
			entity.HomePhone = dto.HomePhone
			entity.Extension = dto.Extension
			entity.Photo = dto.Photo
			entity.Notes = dto.Notes
			entity.ReportsTo = dto.ReportsTo
			entity.PhotoPath = dto.PhotoPath
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As Employee) As  EmployeeDto
			Dim dto As New  EmployeeDto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.EmployeeID = entity.EmployeeID
			dto.LastName = entity.LastName
			dto.FirstName = entity.FirstName
			dto.Title = entity.Title
			dto.TitleOfCourtesy = entity.TitleOfCourtesy
			dto.BirthDate = entity.BirthDate
			dto.HireDate = entity.HireDate
			dto.Address = entity.Address
			dto.City = entity.City
			dto.Region = entity.Region
			dto.PostalCode = entity.PostalCode
			dto.Country = entity.Country
			dto.HomePhone = entity.HomePhone
			dto.Extension = entity.Extension
			dto.Photo = entity.Photo
			dto.Notes = entity.Notes
			dto.ReportsTo = entity.ReportsTo
			dto.PhotoPath = entity.PhotoPath
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As Employee, ByVal dto As EmployeeDto)
			Dim employeeAssembler = new EmployeeAssembler()
			dto.Employee1 = employeeAssembler.Assemble(entity.Employee1)

	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As Employee, ByVal dto As EmployeeDto)
			Dim territoryAssembler = new TerritoryAssembler()

			dto.Territories = new List(Of TerritoryDto)()
			For Each item As Territory In entity.Territories
				Dim dtoItem = territoryAssembler.Assemble(item)
				dto.Territories.Add(dtoItem)
			Next
			

			Dim orderAssembler = new OrderAssembler()

			dto.Orders = new List(Of OrderDto)()
			For Each item As Order In entity.Orders
				Dim dtoItem = orderAssembler.Assemble(item)
				dtoItem.Employee = dto
				dto.Orders.Add(dtoItem)
			Next
			

			Dim employeeAssembler = new EmployeeAssembler()

			dto.Employees = new List(Of EmployeeDto)()
			For Each item As Employee In entity.Employees
				Dim dtoItem = employeeAssembler.Assemble(item)
				dtoItem.Employee1 = dto
				dto.Employees.Add(dtoItem)
			Next
			

	    End Sub
	End Class
	
	
	Partial Public Class EmployeeAssembler
		Inherits EmployeeAssemblerBase
		Implements IEmployeeAssembler
	
	End Class
	
	Public Interface IDomainClass1Assembler
		Inherits IAssembler(Of DomainClass1Dto, DomainClass1)
	
	End Interface
	
	Partial Public Class DomainClass1AssemblerBase
		Inherits Assembler(Of DomainClass1Dto, DomainClass1)
	
		''' <summary>
		''' Invoked after the DomainClass1Dto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="DomainClass1Dto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As DomainClass1Dto)
		End Sub
	
		''' <summary>
		''' Invoked after the DomainClass1 instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="DomainClass1"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As DomainClass1)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As DomainClass1, ByVal dto As DomainClass1Dto) As DomainClass1
			If entity Is Nothing Then
				entity = New DomainClass1()
			End If
	
			entity.FPISFS = dto.FPISFS
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As DomainClass1) As  DomainClass1Dto
			Dim dto As New  DomainClass1Dto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.FPISFS = entity.FPISFS
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As DomainClass1, ByVal dto As DomainClass1Dto)
	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As DomainClass1, ByVal dto As DomainClass1Dto)
	    End Sub
	End Class
	
	
	Partial Public Class DomainClass1Assembler
		Inherits DomainClass1AssemblerBase
		Implements IDomainClass1Assembler
	
	End Class
	
	Public Interface ICustomerAssembler
		Inherits IAssembler(Of CustomerDto, Customer)
	
	End Interface
	
	Partial Public Class CustomerAssemblerBase
		Inherits Assembler(Of CustomerDto, Customer)
	
		''' <summary>
		''' Invoked after the CustomerDto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="CustomerDto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As CustomerDto)
		End Sub
	
		''' <summary>
		''' Invoked after the Customer instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="Customer"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As Customer)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As Customer, ByVal dto As CustomerDto) As Customer
			If entity Is Nothing Then
				entity = New Customer()
			End If
	
			entity.CustomerID = dto.CustomerID
			entity.CompanyName = dto.CompanyName
			entity.ContactName = dto.ContactName
			entity.ContactTitle = dto.ContactTitle
			entity.Address = dto.Address
			entity.City = dto.City
			entity.Region = dto.Region
			entity.PostalCode = dto.PostalCode
			entity.Country = dto.Country
			entity.Phone = dto.Phone
			entity.Fax = dto.Fax
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As Customer) As  CustomerDto
			Dim dto As New  CustomerDto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.CustomerID = entity.CustomerID
			dto.CompanyName = entity.CompanyName
			dto.ContactName = entity.ContactName
			dto.ContactTitle = entity.ContactTitle
			dto.Address = entity.Address
			dto.City = entity.City
			dto.Region = entity.Region
			dto.PostalCode = entity.PostalCode
			dto.Country = entity.Country
			dto.Phone = entity.Phone
			dto.Fax = entity.Fax
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As Customer, ByVal dto As CustomerDto)
	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As Customer, ByVal dto As CustomerDto)
			Dim orderAssembler = new OrderAssembler()

			dto.Orders = new List(Of OrderDto)()
			For Each item As Order In entity.Orders
				Dim dtoItem = orderAssembler.Assemble(item)
				dtoItem.Customer = dto
				dto.Orders.Add(dtoItem)
			Next
			

			Dim customerDemographicAssembler = new CustomerDemographicAssembler()

			dto.CustomerDemographics = new List(Of CustomerDemographicDto)()
			For Each item As CustomerDemographic In entity.CustomerDemographics
				Dim dtoItem = customerDemographicAssembler.Assemble(item)
				dto.CustomerDemographics.Add(dtoItem)
			Next
			

	    End Sub
	End Class
	
	
	Partial Public Class CustomerAssembler
		Inherits CustomerAssemblerBase
		Implements ICustomerAssembler
	
	End Class
	
	Public Interface ICustomerDemographicAssembler
		Inherits IAssembler(Of CustomerDemographicDto, CustomerDemographic)
	
	End Interface
	
	Partial Public Class CustomerDemographicAssemblerBase
		Inherits Assembler(Of CustomerDemographicDto, CustomerDemographic)
	
		''' <summary>
		''' Invoked after the CustomerDemographicDto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="CustomerDemographicDto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As CustomerDemographicDto)
		End Sub
	
		''' <summary>
		''' Invoked after the CustomerDemographic instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="CustomerDemographic"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As CustomerDemographic)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As CustomerDemographic, ByVal dto As CustomerDemographicDto) As CustomerDemographic
			If entity Is Nothing Then
				entity = New CustomerDemographic()
			End If
	
			entity.CustomerTypeID = dto.CustomerTypeID
			entity.CustomerDesc = dto.CustomerDesc
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As CustomerDemographic) As  CustomerDemographicDto
			Dim dto As New  CustomerDemographicDto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.CustomerTypeID = entity.CustomerTypeID
			dto.CustomerDesc = entity.CustomerDesc
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As CustomerDemographic, ByVal dto As CustomerDemographicDto)
	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As CustomerDemographic, ByVal dto As CustomerDemographicDto)
			Dim customerAssembler = new CustomerAssembler()

			dto.Customers = new List(Of CustomerDto)()
			For Each item As Customer In entity.Customers
				Dim dtoItem = customerAssembler.Assemble(item)
				dto.Customers.Add(dtoItem)
			Next
			

	    End Sub
	End Class
	
	
	Partial Public Class CustomerDemographicAssembler
		Inherits CustomerDemographicAssemblerBase
		Implements ICustomerDemographicAssembler
	
	End Class
	
	Public Interface ICategoryAssembler
		Inherits IAssembler(Of CategoryDto, Category)
	
	End Interface
	
	Partial Public Class CategoryAssemblerBase
		Inherits Assembler(Of CategoryDto, Category)
	
		''' <summary>
		''' Invoked after the CategoryDto instance is assembled.
		''' </summary>
		''' <param name="dto"><see cref="CategoryDto"/> The Dto instance.</param>
		Partial Private Sub OnDTOAssembled(ByVal dto As CategoryDto)
		End Sub
	
		''' <summary>
		''' Invoked after the Category instance is assembled.
		''' </summary>
		''' <param name="entity">The <see cref="Category"/> instance.</param>
		Partial Private Sub OnEntityAssembled(ByVal entity As Category)
		End Sub
		
		Public Overrides Function Assemble(ByVal entity As Category, ByVal dto As CategoryDto) As Category
			If entity Is Nothing Then
				entity = New Category()
			End If
	
			entity.CategoryID = dto.CategoryID
			entity.CategoryName = dto.CategoryName
			entity.Description = dto.Description
			entity.Picture = dto.Picture
			entity.BoolD = dto.BoolD
	        Me.OnEntityAssembled(entity)
	        Return entity
	   	End Function
		
		Public Overrides Function Assemble(ByVal entity As Category) As  CategoryDto
			Dim dto As New  CategoryDto()
	
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
			dto.DtoKey = KeyUtility.Instance.Convert(key)
			dto.CategoryID = entity.CategoryID
			dto.CategoryName = entity.CategoryName
			dto.Description = entity.Description
			dto.Picture = entity.Picture
			dto.BoolD = entity.BoolD
			
			Me.OnDTOAssembled(dto)
			Return dto
		End Function
	
		Public Overrides Sub AssembleReferences(ByVal entity As Category, ByVal dto As CategoryDto)
	    End Sub
	
		Public Overrides Sub AssembleCollections(ByVal entity As Category, ByVal dto As CategoryDto)
			Dim productAssembler = new ProductAssembler()

			dto.Products = new List(Of ProductDto)()
			For Each item As Product In entity.Products
				Dim dtoItem = productAssembler.Assemble(item)
				dtoItem.Category = dto
				dto.Products.Add(dtoItem)
			Next
			

	    End Sub
	End Class
	
	
	Partial Public Class CategoryAssembler
		Inherits CategoryAssemblerBase
		Implements ICategoryAssembler
	
	End Class
End Namespace
