' Code is generated by Telerik Add OpenAccess Service Wizard
' using PlainDataService.tt template

'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by a tool.
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------
Imports System.ServiceModel
Imports WebApplication.Dto
Imports WebApplication.Assemblers
Imports WebApplication.Repositories
Imports WebApplication.Services
Imports OpenAccessModel.OpenAccessModel
Imports OpenAccessModel
Imports System
Imports System.Linq
Imports System.Linq.Expressions
Imports System.Collections
Imports System.Collections.Generic
Imports System.Runtime.Serialization

''' <summary>
''' EntitiesModelService service class handler.
''' </summary>
<ServiceBehavior(InstanceContextMode := InstanceContextMode.PerCall)> _
Partial Public Class EntitiesModelService 
    Implements IEntitiesModelService

    ''' <summary>
    ''' Maintains a list of objects affected by a business transaction and coordinates 
    ''' the writing out of changes and the resolution of concurrency problems.
    ''' </summary>
    Private _unitOfWork As IEntitiesModelUnitOfWork

    ''' <summary>
    ''' Get or sets the specific UnitOfWork. It maintains a list of objects affected 
    ''' by a business transaction and coordinates the writing out of changes and the resolution of concurrency problems.
    ''' </summary>
    Public Property UnitOfWork() As IEntitiesModelUnitOfWork
        Get
            If Me._unitOfWork Is Nothing Then
                Me._unitOfWork = New EntitiesModel()
            End If

            Return Me._unitOfWork
        End Get
        Set(ByVal value As IEntitiesModelUnitOfWork)
            Me._unitOfWork = value
        End Set
    End Property

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against Category entity.
    ''' </summary>
    Private _categoryservice As ICategoryService

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against Category entity.
    ''' </summary>
    Public Overridable ReadOnly Property CategoryService() As ICategoryService 
        Get
            If Me._categoryservice Is Nothing Then
                Dim assembler As ICategoryAssembler = New CategoryAssembler()
                Dim repository As ICategoryRepository = New CategoryRepository(Me.UnitOfWork)

                Me._categoryservice = New CategoryService(assembler, repository)
            End If
            Return Me._categoryservice
        End Get
    End Property
        
    #Region "Categories CRUD Operations"

    ''' <summary>
    ''' Returns all categories.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadCategories() As IEnumerable(Of CategoryDto) Implements IEntitiesModelService.ReadCategories
        Return Me.CategoryService.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of categories from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadCategoriesPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of CategoryDto) Implements IEntitiesModelService.ReadCategoriesPaged
        Return Me.CategoryService.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all categories filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadCategoriesFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of CategoryDto) Implements IEntitiesModelService.ReadCategoriesFiltered
        Return Me.CategoryService.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of categories from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadCategoriesPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of CategoryDto) Implements IEntitiesModelService.ReadCategoriesPagedAndFiltered
        Return Me.CategoryService.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a category with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadCategory(ByVal dtoKey As String) As CategoryDto Implements IEntitiesModelService.ReadCategory		
        Return Me.CategoryService.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all categories count.
    ''' </summary>
    ''' <returns></returns>
    Public Function CategoriesCount() As Integer Implements IEntitiesModelService.CategoriesCount
        Return Me.CategoryService.Count()
    End Function

    ''' <summary>
    ''' Returns all categories count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function CategoriesCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.CategoriesCountFiltered
        Return Me.CategoryService.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new category from the given dto object into the database.
    ''' </summary>
    ''' <param name="category">The dto object.</param>
    ''' <returns>The dto key of the newly created category.</returns>
    Public Function CreateCategory(ByVal category As CategoryDto) As String Implements IEntitiesModelService.CreateCategory
        Dim key As String = Me.CategoryService.Add(category)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing category in the database from the given dto object.
    ''' </summary>
    ''' <param name="category">The dto object.</param>
    Public Sub UpdateCategory(ByVal category As CategoryDto) Implements IEntitiesModelService.UpdateCategory
        Me.CategoryService.Update(category)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update categories in the database from the given dto object list.
    ''' </summary>
    ''' <param name="categories">The dto object list.</param>
    Public Sub UpdateCategories(ByVal categories As IEnumerable(Of CategoryDto)) Implements IEntitiesModelService.UpdateCategories
        If categories Is Nothing Then
            Return
        End If

        For Each category As CategoryDto In categories
            If category Is Nothing Then
                Continue For
            End If
            
            Me.UpdateCategory(category)
        Next category
    End Sub

    ''' <summary>
    ''' Deletes category from the database by the given dto object.
    ''' </summary>
    ''' <param name="category">The dto object.</param>
    Public Sub DeleteCategory(ByVal category As CategoryDto) Implements IEntitiesModelService.DeleteCategory
        Me.CategoryService.Delete(category)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete categories from the database by the given dto object list.
    ''' </summary>
    ''' <param name="categories">The dto object list.</param>
    Public Sub DeleteCategories(ByVal categories As IEnumerable(Of CategoryDto)) Implements IEntitiesModelService.DeleteCategories
        If categories Is Nothing Then
            Return
        End If

        For Each category As CategoryDto In categories
            If category Is Nothing Then
                Continue For
            End If
            
            Me.DeleteCategory(category)
        Next category
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against Customer entity.
    ''' </summary>
    Private _customerservice As ICustomerService

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against Customer entity.
    ''' </summary>
    Public Overridable ReadOnly Property CustomerService() As ICustomerService 
        Get
            If Me._customerservice Is Nothing Then
                Dim assembler As ICustomerAssembler = New CustomerAssembler()
                Dim repository As ICustomerRepository = New CustomerRepository(Me.UnitOfWork)

                Me._customerservice = New CustomerService(assembler, repository)
            End If
            Return Me._customerservice
        End Get
    End Property
        
    #Region "Customers CRUD Operations"

    ''' <summary>
    ''' Returns all customers.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadCustomers() As IEnumerable(Of CustomerDto) Implements IEntitiesModelService.ReadCustomers
        Return Me.CustomerService.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of customers from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadCustomersPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of CustomerDto) Implements IEntitiesModelService.ReadCustomersPaged
        Return Me.CustomerService.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all customers filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadCustomersFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of CustomerDto) Implements IEntitiesModelService.ReadCustomersFiltered
        Return Me.CustomerService.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of customers from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadCustomersPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of CustomerDto) Implements IEntitiesModelService.ReadCustomersPagedAndFiltered
        Return Me.CustomerService.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a customer with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadCustomer(ByVal dtoKey As String) As CustomerDto Implements IEntitiesModelService.ReadCustomer		
        Return Me.CustomerService.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all customers count.
    ''' </summary>
    ''' <returns></returns>
    Public Function CustomersCount() As Integer Implements IEntitiesModelService.CustomersCount
        Return Me.CustomerService.Count()
    End Function

    ''' <summary>
    ''' Returns all customers count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function CustomersCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.CustomersCountFiltered
        Return Me.CustomerService.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new customer from the given dto object into the database.
    ''' </summary>
    ''' <param name="customer">The dto object.</param>
    ''' <returns>The dto key of the newly created customer.</returns>
    Public Function CreateCustomer(ByVal customer As CustomerDto) As String Implements IEntitiesModelService.CreateCustomer
        Dim key As String = Me.CustomerService.Add(customer)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing customer in the database from the given dto object.
    ''' </summary>
    ''' <param name="customer">The dto object.</param>
    Public Sub UpdateCustomer(ByVal customer As CustomerDto) Implements IEntitiesModelService.UpdateCustomer
        Me.CustomerService.Update(customer)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update customers in the database from the given dto object list.
    ''' </summary>
    ''' <param name="customers">The dto object list.</param>
    Public Sub UpdateCustomers(ByVal customers As IEnumerable(Of CustomerDto)) Implements IEntitiesModelService.UpdateCustomers
        If customers Is Nothing Then
            Return
        End If

        For Each customer As CustomerDto In customers
            If customer Is Nothing Then
                Continue For
            End If
            
            Me.UpdateCustomer(customer)
        Next customer
    End Sub

    ''' <summary>
    ''' Deletes customer from the database by the given dto object.
    ''' </summary>
    ''' <param name="customer">The dto object.</param>
    Public Sub DeleteCustomer(ByVal customer As CustomerDto) Implements IEntitiesModelService.DeleteCustomer
        Me.CustomerService.Delete(customer)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete customers from the database by the given dto object list.
    ''' </summary>
    ''' <param name="customers">The dto object list.</param>
    Public Sub DeleteCustomers(ByVal customers As IEnumerable(Of CustomerDto)) Implements IEntitiesModelService.DeleteCustomers
        If customers Is Nothing Then
            Return
        End If

        For Each customer As CustomerDto In customers
            If customer Is Nothing Then
                Continue For
            End If
            
            Me.DeleteCustomer(customer)
        Next customer
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against CustomerDemographic entity.
    ''' </summary>
    Private _customerdemographicservice As ICustomerDemographicService

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against CustomerDemographic entity.
    ''' </summary>
    Public Overridable ReadOnly Property CustomerDemographicService() As ICustomerDemographicService 
        Get
            If Me._customerdemographicservice Is Nothing Then
                Dim assembler As ICustomerDemographicAssembler = New CustomerDemographicAssembler()
                Dim repository As ICustomerDemographicRepository = New CustomerDemographicRepository(Me.UnitOfWork)

                Me._customerdemographicservice = New CustomerDemographicService(assembler, repository)
            End If
            Return Me._customerdemographicservice
        End Get
    End Property
        
    #Region "CustomerDemographics CRUD Operations"

    ''' <summary>
    ''' Returns all customerdemographics.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadCustomerDemographics() As IEnumerable(Of CustomerDemographicDto) Implements IEntitiesModelService.ReadCustomerDemographics
        Return Me.CustomerDemographicService.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of customerdemographics from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadCustomerDemographicsPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of CustomerDemographicDto) Implements IEntitiesModelService.ReadCustomerDemographicsPaged
        Return Me.CustomerDemographicService.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all customerdemographics filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadCustomerDemographicsFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of CustomerDemographicDto) Implements IEntitiesModelService.ReadCustomerDemographicsFiltered
        Return Me.CustomerDemographicService.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of customerdemographics from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadCustomerDemographicsPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of CustomerDemographicDto) Implements IEntitiesModelService.ReadCustomerDemographicsPagedAndFiltered
        Return Me.CustomerDemographicService.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a customerdemographic with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadCustomerDemographic(ByVal dtoKey As String) As CustomerDemographicDto Implements IEntitiesModelService.ReadCustomerDemographic		
        Return Me.CustomerDemographicService.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all customerdemographics count.
    ''' </summary>
    ''' <returns></returns>
    Public Function CustomerDemographicsCount() As Integer Implements IEntitiesModelService.CustomerDemographicsCount
        Return Me.CustomerDemographicService.Count()
    End Function

    ''' <summary>
    ''' Returns all customerdemographics count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function CustomerDemographicsCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.CustomerDemographicsCountFiltered
        Return Me.CustomerDemographicService.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new customerdemographic from the given dto object into the database.
    ''' </summary>
    ''' <param name="customerdemographic">The dto object.</param>
    ''' <returns>The dto key of the newly created customerdemographic.</returns>
    Public Function CreateCustomerDemographic(ByVal customerdemographic As CustomerDemographicDto) As String Implements IEntitiesModelService.CreateCustomerDemographic
        Dim key As String = Me.CustomerDemographicService.Add(customerdemographic)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing customerdemographic in the database from the given dto object.
    ''' </summary>
    ''' <param name="customerdemographic">The dto object.</param>
    Public Sub UpdateCustomerDemographic(ByVal customerdemographic As CustomerDemographicDto) Implements IEntitiesModelService.UpdateCustomerDemographic
        Me.CustomerDemographicService.Update(customerdemographic)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update customerdemographics in the database from the given dto object list.
    ''' </summary>
    ''' <param name="customerdemographics">The dto object list.</param>
    Public Sub UpdateCustomerDemographics(ByVal customerdemographics As IEnumerable(Of CustomerDemographicDto)) Implements IEntitiesModelService.UpdateCustomerDemographics
        If customerdemographics Is Nothing Then
            Return
        End If

        For Each customerdemographic As CustomerDemographicDto In customerdemographics
            If customerdemographic Is Nothing Then
                Continue For
            End If
            
            Me.UpdateCustomerDemographic(customerdemographic)
        Next customerdemographic
    End Sub

    ''' <summary>
    ''' Deletes customerdemographic from the database by the given dto object.
    ''' </summary>
    ''' <param name="customerdemographic">The dto object.</param>
    Public Sub DeleteCustomerDemographic(ByVal customerdemographic As CustomerDemographicDto) Implements IEntitiesModelService.DeleteCustomerDemographic
        Me.CustomerDemographicService.Delete(customerdemographic)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete customerdemographics from the database by the given dto object list.
    ''' </summary>
    ''' <param name="customerdemographics">The dto object list.</param>
    Public Sub DeleteCustomerDemographics(ByVal customerdemographics As IEnumerable(Of CustomerDemographicDto)) Implements IEntitiesModelService.DeleteCustomerDemographics
        If customerdemographics Is Nothing Then
            Return
        End If

        For Each customerdemographic As CustomerDemographicDto In customerdemographics
            If customerdemographic Is Nothing Then
                Continue For
            End If
            
            Me.DeleteCustomerDemographic(customerdemographic)
        Next customerdemographic
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against DomainClass1 entity.
    ''' </summary>
    Private _domainclass1service As IDomainClass1Service

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against DomainClass1 entity.
    ''' </summary>
    Public Overridable ReadOnly Property DomainClass1Service() As IDomainClass1Service 
        Get
            If Me._domainclass1service Is Nothing Then
                Dim assembler As IDomainClass1Assembler = New DomainClass1Assembler()
                Dim repository As IDomainClass1Repository = New DomainClass1Repository(Me.UnitOfWork)

                Me._domainclass1service = New DomainClass1Service(assembler, repository)
            End If
            Return Me._domainclass1service
        End Get
    End Property
        
    #Region "DomainClass1s CRUD Operations"

    ''' <summary>
    ''' Returns all domainclass1s.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadDomainClass1s() As IEnumerable(Of DomainClass1Dto) Implements IEntitiesModelService.ReadDomainClass1s
        Return Me.DomainClass1Service.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of domainclass1s from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadDomainClass1sPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of DomainClass1Dto) Implements IEntitiesModelService.ReadDomainClass1sPaged
        Return Me.DomainClass1Service.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all domainclass1s filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadDomainClass1sFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of DomainClass1Dto) Implements IEntitiesModelService.ReadDomainClass1sFiltered
        Return Me.DomainClass1Service.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of domainclass1s from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadDomainClass1sPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of DomainClass1Dto) Implements IEntitiesModelService.ReadDomainClass1sPagedAndFiltered
        Return Me.DomainClass1Service.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a domainclass1 with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadDomainClass1(ByVal dtoKey As String) As DomainClass1Dto Implements IEntitiesModelService.ReadDomainClass1		
        Return Me.DomainClass1Service.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all domainclass1s count.
    ''' </summary>
    ''' <returns></returns>
    Public Function DomainClass1sCount() As Integer Implements IEntitiesModelService.DomainClass1sCount
        Return Me.DomainClass1Service.Count()
    End Function

    ''' <summary>
    ''' Returns all domainclass1s count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function DomainClass1sCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.DomainClass1sCountFiltered
        Return Me.DomainClass1Service.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new domainclass1 from the given dto object into the database.
    ''' </summary>
    ''' <param name="domainclass1">The dto object.</param>
    ''' <returns>The dto key of the newly created domainclass1.</returns>
    Public Function CreateDomainClass1(ByVal domainclass1 As DomainClass1Dto) As String Implements IEntitiesModelService.CreateDomainClass1
        Dim key As String = Me.DomainClass1Service.Add(domainclass1)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing domainclass1 in the database from the given dto object.
    ''' </summary>
    ''' <param name="domainclass1">The dto object.</param>
    Public Sub UpdateDomainClass1(ByVal domainclass1 As DomainClass1Dto) Implements IEntitiesModelService.UpdateDomainClass1
        Me.DomainClass1Service.Update(domainclass1)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update domainclass1s in the database from the given dto object list.
    ''' </summary>
    ''' <param name="domainclass1s">The dto object list.</param>
    Public Sub UpdateDomainClass1s(ByVal domainclass1s As IEnumerable(Of DomainClass1Dto)) Implements IEntitiesModelService.UpdateDomainClass1s
        If domainclass1s Is Nothing Then
            Return
        End If

        For Each domainclass1 As DomainClass1Dto In domainclass1s
            If domainclass1 Is Nothing Then
                Continue For
            End If
            
            Me.UpdateDomainClass1(domainclass1)
        Next domainclass1
    End Sub

    ''' <summary>
    ''' Deletes domainclass1 from the database by the given dto object.
    ''' </summary>
    ''' <param name="domainclass1">The dto object.</param>
    Public Sub DeleteDomainClass1(ByVal domainclass1 As DomainClass1Dto) Implements IEntitiesModelService.DeleteDomainClass1
        Me.DomainClass1Service.Delete(domainclass1)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete domainclass1s from the database by the given dto object list.
    ''' </summary>
    ''' <param name="domainclass1s">The dto object list.</param>
    Public Sub DeleteDomainClass1s(ByVal domainclass1s As IEnumerable(Of DomainClass1Dto)) Implements IEntitiesModelService.DeleteDomainClass1s
        If domainclass1s Is Nothing Then
            Return
        End If

        For Each domainclass1 As DomainClass1Dto In domainclass1s
            If domainclass1 Is Nothing Then
                Continue For
            End If
            
            Me.DeleteDomainClass1(domainclass1)
        Next domainclass1
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against Employee entity.
    ''' </summary>
    Private _employeeservice As IEmployeeService

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against Employee entity.
    ''' </summary>
    Public Overridable ReadOnly Property EmployeeService() As IEmployeeService 
        Get
            If Me._employeeservice Is Nothing Then
                Dim assembler As IEmployeeAssembler = New EmployeeAssembler()
                Dim repository As IEmployeeRepository = New EmployeeRepository(Me.UnitOfWork)

                Me._employeeservice = New EmployeeService(assembler, repository)
            End If
            Return Me._employeeservice
        End Get
    End Property
        
    #Region "Employees CRUD Operations"

    ''' <summary>
    ''' Returns all employees.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadEmployees() As IEnumerable(Of EmployeeDto) Implements IEntitiesModelService.ReadEmployees
        Return Me.EmployeeService.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of employees from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadEmployeesPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of EmployeeDto) Implements IEntitiesModelService.ReadEmployeesPaged
        Return Me.EmployeeService.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all employees filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadEmployeesFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of EmployeeDto) Implements IEntitiesModelService.ReadEmployeesFiltered
        Return Me.EmployeeService.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of employees from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadEmployeesPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of EmployeeDto) Implements IEntitiesModelService.ReadEmployeesPagedAndFiltered
        Return Me.EmployeeService.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a employee with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadEmployee(ByVal dtoKey As String) As EmployeeDto Implements IEntitiesModelService.ReadEmployee		
        Return Me.EmployeeService.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all employees count.
    ''' </summary>
    ''' <returns></returns>
    Public Function EmployeesCount() As Integer Implements IEntitiesModelService.EmployeesCount
        Return Me.EmployeeService.Count()
    End Function

    ''' <summary>
    ''' Returns all employees count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function EmployeesCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.EmployeesCountFiltered
        Return Me.EmployeeService.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new employee from the given dto object into the database.
    ''' </summary>
    ''' <param name="employee">The dto object.</param>
    ''' <returns>The dto key of the newly created employee.</returns>
    Public Function CreateEmployee(ByVal employee As EmployeeDto) As String Implements IEntitiesModelService.CreateEmployee
        Dim key As String = Me.EmployeeService.Add(employee)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing employee in the database from the given dto object.
    ''' </summary>
    ''' <param name="employee">The dto object.</param>
    Public Sub UpdateEmployee(ByVal employee As EmployeeDto) Implements IEntitiesModelService.UpdateEmployee
        Me.EmployeeService.Update(employee)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update employees in the database from the given dto object list.
    ''' </summary>
    ''' <param name="employees">The dto object list.</param>
    Public Sub UpdateEmployees(ByVal employees As IEnumerable(Of EmployeeDto)) Implements IEntitiesModelService.UpdateEmployees
        If employees Is Nothing Then
            Return
        End If

        For Each employee As EmployeeDto In employees
            If employee Is Nothing Then
                Continue For
            End If
            
            Me.UpdateEmployee(employee)
        Next employee
    End Sub

    ''' <summary>
    ''' Deletes employee from the database by the given dto object.
    ''' </summary>
    ''' <param name="employee">The dto object.</param>
    Public Sub DeleteEmployee(ByVal employee As EmployeeDto) Implements IEntitiesModelService.DeleteEmployee
        Me.EmployeeService.Delete(employee)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete employees from the database by the given dto object list.
    ''' </summary>
    ''' <param name="employees">The dto object list.</param>
    Public Sub DeleteEmployees(ByVal employees As IEnumerable(Of EmployeeDto)) Implements IEntitiesModelService.DeleteEmployees
        If employees Is Nothing Then
            Return
        End If

        For Each employee As EmployeeDto In employees
            If employee Is Nothing Then
                Continue For
            End If
            
            Me.DeleteEmployee(employee)
        Next employee
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against Order entity.
    ''' </summary>
    Private _orderservice As IOrderService

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against Order entity.
    ''' </summary>
    Public Overridable ReadOnly Property OrderService() As IOrderService 
        Get
            If Me._orderservice Is Nothing Then
                Dim assembler As IOrderAssembler = New OrderAssembler()
                Dim repository As IOrderRepository = New OrderRepository(Me.UnitOfWork)

                Me._orderservice = New OrderService(assembler, repository)
            End If
            Return Me._orderservice
        End Get
    End Property
        
    #Region "Orders CRUD Operations"

    ''' <summary>
    ''' Returns all orders.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadOrders() As IEnumerable(Of OrderDto) Implements IEntitiesModelService.ReadOrders
        Return Me.OrderService.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of orders from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadOrdersPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of OrderDto) Implements IEntitiesModelService.ReadOrdersPaged
        Return Me.OrderService.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all orders filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadOrdersFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of OrderDto) Implements IEntitiesModelService.ReadOrdersFiltered
        Return Me.OrderService.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of orders from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadOrdersPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of OrderDto) Implements IEntitiesModelService.ReadOrdersPagedAndFiltered
        Return Me.OrderService.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a order with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadOrder(ByVal dtoKey As String) As OrderDto Implements IEntitiesModelService.ReadOrder		
        Return Me.OrderService.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all orders count.
    ''' </summary>
    ''' <returns></returns>
    Public Function OrdersCount() As Integer Implements IEntitiesModelService.OrdersCount
        Return Me.OrderService.Count()
    End Function

    ''' <summary>
    ''' Returns all orders count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function OrdersCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.OrdersCountFiltered
        Return Me.OrderService.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new order from the given dto object into the database.
    ''' </summary>
    ''' <param name="order">The dto object.</param>
    ''' <returns>The dto key of the newly created order.</returns>
    Public Function CreateOrder(ByVal order As OrderDto) As String Implements IEntitiesModelService.CreateOrder
        Dim key As String = Me.OrderService.Add(order)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing order in the database from the given dto object.
    ''' </summary>
    ''' <param name="order">The dto object.</param>
    Public Sub UpdateOrder(ByVal order As OrderDto) Implements IEntitiesModelService.UpdateOrder
        Me.OrderService.Update(order)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update orders in the database from the given dto object list.
    ''' </summary>
    ''' <param name="orders">The dto object list.</param>
    Public Sub UpdateOrders(ByVal orders As IEnumerable(Of OrderDto)) Implements IEntitiesModelService.UpdateOrders
        If orders Is Nothing Then
            Return
        End If

        For Each order As OrderDto In orders
            If order Is Nothing Then
                Continue For
            End If
            
            Me.UpdateOrder(order)
        Next order
    End Sub

    ''' <summary>
    ''' Deletes order from the database by the given dto object.
    ''' </summary>
    ''' <param name="order">The dto object.</param>
    Public Sub DeleteOrder(ByVal order As OrderDto) Implements IEntitiesModelService.DeleteOrder
        Me.OrderService.Delete(order)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete orders from the database by the given dto object list.
    ''' </summary>
    ''' <param name="orders">The dto object list.</param>
    Public Sub DeleteOrders(ByVal orders As IEnumerable(Of OrderDto)) Implements IEntitiesModelService.DeleteOrders
        If orders Is Nothing Then
            Return
        End If

        For Each order As OrderDto In orders
            If order Is Nothing Then
                Continue For
            End If
            
            Me.DeleteOrder(order)
        Next order
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against OrderDetail entity.
    ''' </summary>
    Private _orderdetailservice As IOrderDetailService

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against OrderDetail entity.
    ''' </summary>
    Public Overridable ReadOnly Property OrderDetailService() As IOrderDetailService 
        Get
            If Me._orderdetailservice Is Nothing Then
                Dim assembler As IOrderDetailAssembler = New OrderDetailAssembler()
                Dim repository As IOrderDetailRepository = New OrderDetailRepository(Me.UnitOfWork)

                Me._orderdetailservice = New OrderDetailService(assembler, repository)
            End If
            Return Me._orderdetailservice
        End Get
    End Property
        
    #Region "OrderDetails CRUD Operations"

    ''' <summary>
    ''' Returns all orderdetails.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadOrderDetails() As IEnumerable(Of OrderDetailDto) Implements IEntitiesModelService.ReadOrderDetails
        Return Me.OrderDetailService.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of orderdetails from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadOrderDetailsPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of OrderDetailDto) Implements IEntitiesModelService.ReadOrderDetailsPaged
        Return Me.OrderDetailService.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all orderdetails filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadOrderDetailsFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of OrderDetailDto) Implements IEntitiesModelService.ReadOrderDetailsFiltered
        Return Me.OrderDetailService.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of orderdetails from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadOrderDetailsPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of OrderDetailDto) Implements IEntitiesModelService.ReadOrderDetailsPagedAndFiltered
        Return Me.OrderDetailService.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a orderdetail with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadOrderDetail(ByVal dtoKey As String) As OrderDetailDto Implements IEntitiesModelService.ReadOrderDetail		
        Return Me.OrderDetailService.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all orderdetails count.
    ''' </summary>
    ''' <returns></returns>
    Public Function OrderDetailsCount() As Integer Implements IEntitiesModelService.OrderDetailsCount
        Return Me.OrderDetailService.Count()
    End Function

    ''' <summary>
    ''' Returns all orderdetails count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function OrderDetailsCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.OrderDetailsCountFiltered
        Return Me.OrderDetailService.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new orderdetail from the given dto object into the database.
    ''' </summary>
    ''' <param name="orderdetail">The dto object.</param>
    ''' <returns>The dto key of the newly created orderdetail.</returns>
    Public Function CreateOrderDetail(ByVal orderdetail As OrderDetailDto) As String Implements IEntitiesModelService.CreateOrderDetail
        Dim key As String = Me.OrderDetailService.Add(orderdetail)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing orderdetail in the database from the given dto object.
    ''' </summary>
    ''' <param name="orderdetail">The dto object.</param>
    Public Sub UpdateOrderDetail(ByVal orderdetail As OrderDetailDto) Implements IEntitiesModelService.UpdateOrderDetail
        Me.OrderDetailService.Update(orderdetail)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update orderdetails in the database from the given dto object list.
    ''' </summary>
    ''' <param name="orderdetails">The dto object list.</param>
    Public Sub UpdateOrderDetails(ByVal orderdetails As IEnumerable(Of OrderDetailDto)) Implements IEntitiesModelService.UpdateOrderDetails
        If orderdetails Is Nothing Then
            Return
        End If

        For Each orderdetail As OrderDetailDto In orderdetails
            If orderdetail Is Nothing Then
                Continue For
            End If
            
            Me.UpdateOrderDetail(orderdetail)
        Next orderdetail
    End Sub

    ''' <summary>
    ''' Deletes orderdetail from the database by the given dto object.
    ''' </summary>
    ''' <param name="orderdetail">The dto object.</param>
    Public Sub DeleteOrderDetail(ByVal orderdetail As OrderDetailDto) Implements IEntitiesModelService.DeleteOrderDetail
        Me.OrderDetailService.Delete(orderdetail)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete orderdetails from the database by the given dto object list.
    ''' </summary>
    ''' <param name="orderdetails">The dto object list.</param>
    Public Sub DeleteOrderDetails(ByVal orderdetails As IEnumerable(Of OrderDetailDto)) Implements IEntitiesModelService.DeleteOrderDetails
        If orderdetails Is Nothing Then
            Return
        End If

        For Each orderdetail As OrderDetailDto In orderdetails
            If orderdetail Is Nothing Then
                Continue For
            End If
            
            Me.DeleteOrderDetail(orderdetail)
        Next orderdetail
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against Product entity.
    ''' </summary>
    Private _productservice As IProductService

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against Product entity.
    ''' </summary>
    Public Overridable ReadOnly Property ProductService() As IProductService 
        Get
            If Me._productservice Is Nothing Then
                Dim assembler As IProductAssembler = New ProductAssembler()
                Dim repository As IProductRepository = New ProductRepository(Me.UnitOfWork)

                Me._productservice = New ProductService(assembler, repository)
            End If
            Return Me._productservice
        End Get
    End Property
        
    #Region "Products CRUD Operations"

    ''' <summary>
    ''' Returns all products.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadProducts() As IEnumerable(Of ProductDto) Implements IEntitiesModelService.ReadProducts
        Return Me.ProductService.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of products from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadProductsPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of ProductDto) Implements IEntitiesModelService.ReadProductsPaged
        Return Me.ProductService.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all products filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadProductsFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of ProductDto) Implements IEntitiesModelService.ReadProductsFiltered
        Return Me.ProductService.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of products from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadProductsPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of ProductDto) Implements IEntitiesModelService.ReadProductsPagedAndFiltered
        Return Me.ProductService.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a product with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadProduct(ByVal dtoKey As String) As ProductDto Implements IEntitiesModelService.ReadProduct		
        Return Me.ProductService.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all products count.
    ''' </summary>
    ''' <returns></returns>
    Public Function ProductsCount() As Integer Implements IEntitiesModelService.ProductsCount
        Return Me.ProductService.Count()
    End Function

    ''' <summary>
    ''' Returns all products count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ProductsCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.ProductsCountFiltered
        Return Me.ProductService.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new product from the given dto object into the database.
    ''' </summary>
    ''' <param name="product">The dto object.</param>
    ''' <returns>The dto key of the newly created product.</returns>
    Public Function CreateProduct(ByVal product As ProductDto) As String Implements IEntitiesModelService.CreateProduct
        Dim key As String = Me.ProductService.Add(product)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing product in the database from the given dto object.
    ''' </summary>
    ''' <param name="product">The dto object.</param>
    Public Sub UpdateProduct(ByVal product As ProductDto) Implements IEntitiesModelService.UpdateProduct
        Me.ProductService.Update(product)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update products in the database from the given dto object list.
    ''' </summary>
    ''' <param name="products">The dto object list.</param>
    Public Sub UpdateProducts(ByVal products As IEnumerable(Of ProductDto)) Implements IEntitiesModelService.UpdateProducts
        If products Is Nothing Then
            Return
        End If

        For Each product As ProductDto In products
            If product Is Nothing Then
                Continue For
            End If
            
            Me.UpdateProduct(product)
        Next product
    End Sub

    ''' <summary>
    ''' Deletes product from the database by the given dto object.
    ''' </summary>
    ''' <param name="product">The dto object.</param>
    Public Sub DeleteProduct(ByVal product As ProductDto) Implements IEntitiesModelService.DeleteProduct
        Me.ProductService.Delete(product)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete products from the database by the given dto object list.
    ''' </summary>
    ''' <param name="products">The dto object list.</param>
    Public Sub DeleteProducts(ByVal products As IEnumerable(Of ProductDto)) Implements IEntitiesModelService.DeleteProducts
        If products Is Nothing Then
            Return
        End If

        For Each product As ProductDto In products
            If product Is Nothing Then
                Continue For
            End If
            
            Me.DeleteProduct(product)
        Next product
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against Region entity.
    ''' </summary>
    Private _regionservice As IRegionService

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against Region entity.
    ''' </summary>
    Public Overridable ReadOnly Property RegionService() As IRegionService 
        Get
            If Me._regionservice Is Nothing Then
                Dim assembler As IRegionAssembler = New RegionAssembler()
                Dim repository As IRegionRepository = New RegionRepository(Me.UnitOfWork)

                Me._regionservice = New RegionService(assembler, repository)
            End If
            Return Me._regionservice
        End Get
    End Property
        
    #Region "Regions CRUD Operations"

    ''' <summary>
    ''' Returns all regions.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadRegions() As IEnumerable(Of RegionDto) Implements IEntitiesModelService.ReadRegions
        Return Me.RegionService.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of regions from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadRegionsPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of RegionDto) Implements IEntitiesModelService.ReadRegionsPaged
        Return Me.RegionService.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all regions filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadRegionsFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of RegionDto) Implements IEntitiesModelService.ReadRegionsFiltered
        Return Me.RegionService.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of regions from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadRegionsPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of RegionDto) Implements IEntitiesModelService.ReadRegionsPagedAndFiltered
        Return Me.RegionService.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a region with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadRegion(ByVal dtoKey As String) As RegionDto Implements IEntitiesModelService.ReadRegion		
        Return Me.RegionService.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all regions count.
    ''' </summary>
    ''' <returns></returns>
    Public Function RegionsCount() As Integer Implements IEntitiesModelService.RegionsCount
        Return Me.RegionService.Count()
    End Function

    ''' <summary>
    ''' Returns all regions count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function RegionsCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.RegionsCountFiltered
        Return Me.RegionService.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new region from the given dto object into the database.
    ''' </summary>
    ''' <param name="region">The dto object.</param>
    ''' <returns>The dto key of the newly created region.</returns>
    Public Function CreateRegion(ByVal region As RegionDto) As String Implements IEntitiesModelService.CreateRegion
        Dim key As String = Me.RegionService.Add(region)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing region in the database from the given dto object.
    ''' </summary>
    ''' <param name="region">The dto object.</param>
    Public Sub UpdateRegion(ByVal region As RegionDto) Implements IEntitiesModelService.UpdateRegion
        Me.RegionService.Update(region)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update regions in the database from the given dto object list.
    ''' </summary>
    ''' <param name="regions">The dto object list.</param>
    Public Sub UpdateRegions(ByVal regions As IEnumerable(Of RegionDto)) Implements IEntitiesModelService.UpdateRegions
        If regions Is Nothing Then
            Return
        End If

        For Each region As RegionDto In regions
            If region Is Nothing Then
                Continue For
            End If
            
            Me.UpdateRegion(region)
        Next region
    End Sub

    ''' <summary>
    ''' Deletes region from the database by the given dto object.
    ''' </summary>
    ''' <param name="region">The dto object.</param>
    Public Sub DeleteRegion(ByVal region As RegionDto) Implements IEntitiesModelService.DeleteRegion
        Me.RegionService.Delete(region)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete regions from the database by the given dto object list.
    ''' </summary>
    ''' <param name="regions">The dto object list.</param>
    Public Sub DeleteRegions(ByVal regions As IEnumerable(Of RegionDto)) Implements IEntitiesModelService.DeleteRegions
        If regions Is Nothing Then
            Return
        End If

        For Each region As RegionDto In regions
            If region Is Nothing Then
                Continue For
            End If
            
            Me.DeleteRegion(region)
        Next region
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against Shipper entity.
    ''' </summary>
    Private _shipperservice As IShipperService

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against Shipper entity.
    ''' </summary>
    Public Overridable ReadOnly Property ShipperService() As IShipperService 
        Get
            If Me._shipperservice Is Nothing Then
                Dim assembler As IShipperAssembler = New ShipperAssembler()
                Dim repository As IShipperRepository = New ShipperRepository(Me.UnitOfWork)

                Me._shipperservice = New ShipperService(assembler, repository)
            End If
            Return Me._shipperservice
        End Get
    End Property
        
    #Region "Shippers CRUD Operations"

    ''' <summary>
    ''' Returns all shippers.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadShippers() As IEnumerable(Of ShipperDto) Implements IEntitiesModelService.ReadShippers
        Return Me.ShipperService.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of shippers from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadShippersPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of ShipperDto) Implements IEntitiesModelService.ReadShippersPaged
        Return Me.ShipperService.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all shippers filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadShippersFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of ShipperDto) Implements IEntitiesModelService.ReadShippersFiltered
        Return Me.ShipperService.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of shippers from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadShippersPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of ShipperDto) Implements IEntitiesModelService.ReadShippersPagedAndFiltered
        Return Me.ShipperService.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a shipper with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadShipper(ByVal dtoKey As String) As ShipperDto Implements IEntitiesModelService.ReadShipper		
        Return Me.ShipperService.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all shippers count.
    ''' </summary>
    ''' <returns></returns>
    Public Function ShippersCount() As Integer Implements IEntitiesModelService.ShippersCount
        Return Me.ShipperService.Count()
    End Function

    ''' <summary>
    ''' Returns all shippers count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ShippersCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.ShippersCountFiltered
        Return Me.ShipperService.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new shipper from the given dto object into the database.
    ''' </summary>
    ''' <param name="shipper">The dto object.</param>
    ''' <returns>The dto key of the newly created shipper.</returns>
    Public Function CreateShipper(ByVal shipper As ShipperDto) As String Implements IEntitiesModelService.CreateShipper
        Dim key As String = Me.ShipperService.Add(shipper)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing shipper in the database from the given dto object.
    ''' </summary>
    ''' <param name="shipper">The dto object.</param>
    Public Sub UpdateShipper(ByVal shipper As ShipperDto) Implements IEntitiesModelService.UpdateShipper
        Me.ShipperService.Update(shipper)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update shippers in the database from the given dto object list.
    ''' </summary>
    ''' <param name="shippers">The dto object list.</param>
    Public Sub UpdateShippers(ByVal shippers As IEnumerable(Of ShipperDto)) Implements IEntitiesModelService.UpdateShippers
        If shippers Is Nothing Then
            Return
        End If

        For Each shipper As ShipperDto In shippers
            If shipper Is Nothing Then
                Continue For
            End If
            
            Me.UpdateShipper(shipper)
        Next shipper
    End Sub

    ''' <summary>
    ''' Deletes shipper from the database by the given dto object.
    ''' </summary>
    ''' <param name="shipper">The dto object.</param>
    Public Sub DeleteShipper(ByVal shipper As ShipperDto) Implements IEntitiesModelService.DeleteShipper
        Me.ShipperService.Delete(shipper)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete shippers from the database by the given dto object list.
    ''' </summary>
    ''' <param name="shippers">The dto object list.</param>
    Public Sub DeleteShippers(ByVal shippers As IEnumerable(Of ShipperDto)) Implements IEntitiesModelService.DeleteShippers
        If shippers Is Nothing Then
            Return
        End If

        For Each shipper As ShipperDto In shippers
            If shipper Is Nothing Then
                Continue For
            End If
            
            Me.DeleteShipper(shipper)
        Next shipper
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against Supplier entity.
    ''' </summary>
    Private _supplierservice As ISupplierService

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against Supplier entity.
    ''' </summary>
    Public Overridable ReadOnly Property SupplierService() As ISupplierService 
        Get
            If Me._supplierservice Is Nothing Then
                Dim assembler As ISupplierAssembler = New SupplierAssembler()
                Dim repository As ISupplierRepository = New SupplierRepository(Me.UnitOfWork)

                Me._supplierservice = New SupplierService(assembler, repository)
            End If
            Return Me._supplierservice
        End Get
    End Property
        
    #Region "Suppliers CRUD Operations"

    ''' <summary>
    ''' Returns all suppliers.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadSuppliers() As IEnumerable(Of SupplierDto) Implements IEntitiesModelService.ReadSuppliers
        Return Me.SupplierService.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of suppliers from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadSuppliersPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of SupplierDto) Implements IEntitiesModelService.ReadSuppliersPaged
        Return Me.SupplierService.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all suppliers filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadSuppliersFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of SupplierDto) Implements IEntitiesModelService.ReadSuppliersFiltered
        Return Me.SupplierService.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of suppliers from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadSuppliersPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of SupplierDto) Implements IEntitiesModelService.ReadSuppliersPagedAndFiltered
        Return Me.SupplierService.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a supplier with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadSupplier(ByVal dtoKey As String) As SupplierDto Implements IEntitiesModelService.ReadSupplier		
        Return Me.SupplierService.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all suppliers count.
    ''' </summary>
    ''' <returns></returns>
    Public Function SuppliersCount() As Integer Implements IEntitiesModelService.SuppliersCount
        Return Me.SupplierService.Count()
    End Function

    ''' <summary>
    ''' Returns all suppliers count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function SuppliersCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.SuppliersCountFiltered
        Return Me.SupplierService.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new supplier from the given dto object into the database.
    ''' </summary>
    ''' <param name="supplier">The dto object.</param>
    ''' <returns>The dto key of the newly created supplier.</returns>
    Public Function CreateSupplier(ByVal supplier As SupplierDto) As String Implements IEntitiesModelService.CreateSupplier
        Dim key As String = Me.SupplierService.Add(supplier)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing supplier in the database from the given dto object.
    ''' </summary>
    ''' <param name="supplier">The dto object.</param>
    Public Sub UpdateSupplier(ByVal supplier As SupplierDto) Implements IEntitiesModelService.UpdateSupplier
        Me.SupplierService.Update(supplier)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update suppliers in the database from the given dto object list.
    ''' </summary>
    ''' <param name="suppliers">The dto object list.</param>
    Public Sub UpdateSuppliers(ByVal suppliers As IEnumerable(Of SupplierDto)) Implements IEntitiesModelService.UpdateSuppliers
        If suppliers Is Nothing Then
            Return
        End If

        For Each supplier As SupplierDto In suppliers
            If supplier Is Nothing Then
                Continue For
            End If
            
            Me.UpdateSupplier(supplier)
        Next supplier
    End Sub

    ''' <summary>
    ''' Deletes supplier from the database by the given dto object.
    ''' </summary>
    ''' <param name="supplier">The dto object.</param>
    Public Sub DeleteSupplier(ByVal supplier As SupplierDto) Implements IEntitiesModelService.DeleteSupplier
        Me.SupplierService.Delete(supplier)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete suppliers from the database by the given dto object list.
    ''' </summary>
    ''' <param name="suppliers">The dto object list.</param>
    Public Sub DeleteSuppliers(ByVal suppliers As IEnumerable(Of SupplierDto)) Implements IEntitiesModelService.DeleteSuppliers
        If suppliers Is Nothing Then
            Return
        End If

        For Each supplier As SupplierDto In suppliers
            If supplier Is Nothing Then
                Continue For
            End If
            
            Me.DeleteSupplier(supplier)
        Next supplier
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' A general purpose generated service used for all CRUD operations against Territory entity.
    ''' </summary>
    Private _territoryservice As ITerritoryService

    ''' <summary>
    ''' Gets or sets the general purpose generated service used for all CRUD operations against Territory entity.
    ''' </summary>
    Public Overridable ReadOnly Property TerritoryService() As ITerritoryService 
        Get
            If Me._territoryservice Is Nothing Then
                Dim assembler As ITerritoryAssembler = New TerritoryAssembler()
                Dim repository As ITerritoryRepository = New TerritoryRepository(Me.UnitOfWork)

                Me._territoryservice = New TerritoryService(assembler, repository)
            End If
            Return Me._territoryservice
        End Get
    End Property
        
    #Region "Territories CRUD Operations"

    ''' <summary>
    ''' Returns all territories.
    ''' </summary>
    ''' <returns></returns>
    Public Function ReadTerritories() As IEnumerable(Of TerritoryDto) Implements IEntitiesModelService.ReadTerritories
        Return Me.TerritoryService.GetAll()
    End Function

    ''' <summary>
    ''' Returns a specified amount of territories from the given start index.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <returns></returns>
    Public Function ReadTerritoriesPaged(ByVal startIndex As Integer, ByVal pageSize As Integer) As IEnumerable(Of TerritoryDto) Implements IEntitiesModelService.ReadTerritoriesPaged
        Return Me.TerritoryService.Find(startIndex, pageSize)
    End Function

    ''' <summary>
    ''' Returns all territories filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadTerritoriesFiltered(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of TerritoryDto) Implements IEntitiesModelService.ReadTerritoriesFiltered
        Return Me.TerritoryService.Find(sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a specified amount of territories from the given start index filtered by the specified filter expression and sorted by the specified sort expression.
    ''' </summary>
    ''' <param name="startIndex">The start index.</param>
    ''' <param name="pageSize">The returned entities count.</param>
    ''' <param name="sortExpression">The sort expression.</param>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function ReadTerritoriesPagedAndFiltered(ByVal startIndex As Integer, ByVal pageSize As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of TerritoryDto) Implements IEntitiesModelService.ReadTerritoriesPagedAndFiltered
        Return Me.TerritoryService.Find(startIndex, pageSize, sortExpression, filterExpression)
    End Function

    ''' <summary>
    ''' Returns a territory with the specified dto key.
    ''' </summary>
    ''' <param name="dtoKey">The specified dto key value.</param>
    ''' <returns></returns>
    Public Function ReadTerritory(ByVal dtoKey As String) As TerritoryDto Implements IEntitiesModelService.ReadTerritory		
        Return Me.TerritoryService.GetByKey(dtoKey)
    End Function

    ''' <summary>
    ''' Returns all territories count.
    ''' </summary>
    ''' <returns></returns>
    Public Function TerritoriesCount() As Integer Implements IEntitiesModelService.TerritoriesCount
        Return Me.TerritoryService.Count()
    End Function

    ''' <summary>
    ''' Returns all territories count filtered by the specified filter expression.
    ''' </summary>
    ''' <param name="filterExpression">The filter expression.</param>
    ''' <returns></returns>
    Public Function TerritoriesCountFiltered(ByVal filterExpression As String) As Integer Implements IEntitiesModelService.TerritoriesCountFiltered
        Return Me.TerritoryService.Count(filterExpression)
    End Function


    ''' <summary>
    ''' Adds a new territory from the given dto object into the database.
    ''' </summary>
    ''' <param name="territory">The dto object.</param>
    ''' <returns>The dto key of the newly created territory.</returns>
    Public Function CreateTerritory(ByVal territory As TerritoryDto) As String Implements IEntitiesModelService.CreateTerritory
        Dim key As String = Me.TerritoryService.Add(territory)
        Me.UnitOfWork.SaveChanges()
        
        Return key
    End Function

    ''' <summary>
    ''' Updates an existing territory in the database from the given dto object.
    ''' </summary>
    ''' <param name="territory">The dto object.</param>
    Public Sub UpdateTerritory(ByVal territory As TerritoryDto) Implements IEntitiesModelService.UpdateTerritory
        Me.TerritoryService.Update(territory)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Update territories in the database from the given dto object list.
    ''' </summary>
    ''' <param name="territories">The dto object list.</param>
    Public Sub UpdateTerritories(ByVal territories As IEnumerable(Of TerritoryDto)) Implements IEntitiesModelService.UpdateTerritories
        If territories Is Nothing Then
            Return
        End If

        For Each territory As TerritoryDto In territories
            If territory Is Nothing Then
                Continue For
            End If
            
            Me.UpdateTerritory(territory)
        Next territory
    End Sub

    ''' <summary>
    ''' Deletes territory from the database by the given dto object.
    ''' </summary>
    ''' <param name="territory">The dto object.</param>
    Public Sub DeleteTerritory(ByVal territory As TerritoryDto) Implements IEntitiesModelService.DeleteTerritory
        Me.TerritoryService.Delete(territory)
        Me.UnitOfWork.SaveChanges()
    End Sub

    ''' <summary>
    ''' Delete territories from the database by the given dto object list.
    ''' </summary>
    ''' <param name="territories">The dto object list.</param>
    Public Sub DeleteTerritories(ByVal territories As IEnumerable(Of TerritoryDto)) Implements IEntitiesModelService.DeleteTerritories
        If territories Is Nothing Then
            Return
        End If

        For Each territory As TerritoryDto In territories
            If territory Is Nothing Then
                Continue For
            End If
            
            Me.DeleteTerritory(territory)
        Next territory
    End Sub
    
    #End Region
    

    ''' <summary>
    ''' EntitiesModelService finalizer.
    ''' </summary>
    Protected Overrides Sub Finalize()
        Try
            Dim context As IDisposable = TryCast(Me.unitOfWork, IDisposable)
            If context IsNot Nothing Then
                context.Dispose()
            End If
        Finally
            MyBase.Finalize()
        End Try
    End Sub

End Class
