﻿Imports WebApplication.Dto
Imports OpenAccessModel

Namespace Assemblers

    Partial Public Class ProductAssembler
        Public Overrides Function Assemble(ByVal entity As Product) As ProductDto
            Dim _productDto As ProductDto = MyBase.Assemble(entity)

            ' Get all of the navigation properties alon with the product DTO
            Me.AssembleNavigational(entity, _productDto)

            Return _productDto
        End Function

        Public Overrides Function Assemble(ByVal entity As Product, ByVal dto As ProductDto) As Product
            Dim orderDetailAssembler = New OrderDetailAssembler()
            Dim categoryAssembler = New CategoryAssembler()
            Dim supplierAssembler = New SupplierAssembler()

            Dim product = MyBase.Assemble(entity, dto)

            For Each item In dto.OrderDetails
                Dim orderDetail = product.OrderDetails.FirstOrDefault(Function(od) od.OrderID = item.OrderID And od.ProductID = item.ProductID)
                If orderDetail Is Nothing Then
                    product.OrderDetails.Add(orderDetailAssembler.Assemble(orderDetail, item))
                Else
                    orderDetail = orderDetailAssembler.Assemble(orderDetail, item)
                End If
            Next

            product.Category = categoryAssembler.Assemble(product.Category, dto.Category)
            product.Supplier = supplierAssembler.Assemble(product.Supplier, dto.Supplier)

            Return product
        End Function
    End Class

End Namespace
