'------------------------------------------------------------------------------
' <auto-generated>
'     This code was generated by a tool.
'
'     Changes to this file may cause incorrect behavior and will be lost if
'     the code is regenerated.
' </auto-generated>
'------------------------------------------------------------------------------
Imports OpenAccessModel.OpenAccessModel
Imports OpenAccessModel
Imports Telerik.OpenAccess
Imports WebApplication.Dto
Imports WebApplication.Assemblers
Imports WebApplication.Repositories
Imports WebApplication.Converters
Imports System
Imports System.Linq
Imports System.Linq.Expressions
Imports System.Collections
Imports System.Collections.Generic
Imports System.Runtime.Serialization

Namespace Services
	
	Public Interface IService(Of TDto As IDtoWithKey, TEntity As Class)
		ReadOnly Property Assembler() As IAssembler(Of TDto, TEntity)
		ReadOnly Property Repository() As IRepository(Of TEntity)
	
		Function Find(ByVal filter As Expression(Of Func(Of TEntity, Boolean))) As IEnumerable(Of TDto)
		Function GetAll() As IEnumerable(Of TDto)
	
		Function Find(ByVal startRowIndex As Integer, ByVal maximumRows As Integer) As IEnumerable(Of TDto)
		Function Find(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of TDto)
		Function Find(ByVal startRowIndex? As Integer, ByVal maximumRows? As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of TDto)
	
		Function Count() As Integer
		Function Count(ByVal filterExpression As String) As Integer
	
		Function GetByKey(ByVal dtoKey As String) As TDto
		Function Add(ByVal dto As TDto) As String
		Sub Update(ByVal dto As TDto)
		Sub Delete(ByVal dto As TDto)
	End Interface
	
	Public MustInherit Partial Class Service(Of TDto As IDtoWithKey, TEntity As Class)
		Implements IService(Of TDto, TEntity)
	
	    Private _assembler As IAssembler(Of TDto, TEntity)
		Private _repository As IRepository(Of TEntity)
	
		Public Sub New(ByVal assembler As IAssembler(Of TDto, TEntity), ByVal repository As IRepository(Of TEntity))
			Me._assembler = assembler
			Me._repository = repository
		End Sub
	
		Public ReadOnly Property Assembler() As IAssembler(Of TDto, TEntity) Implements IService(Of TDto, TEntity).Assembler
			Get
				Return Me._assembler
			End Get
		End Property
	
		Public ReadOnly Property Repository() As IRepository(Of TEntity) Implements IService(Of TDto, TEntity).Repository
			Get
				Return Me._repository
			End Get
		End Property
	
		Public Overridable Function GetAll() As IEnumerable(Of TDto) Implements IService(Of TDto, TEntity).GetAll
			Return Me._assembler.Assemble(Me.Repository.GetAll())
		End Function
	
		Public Overridable Function Find(ByVal filter As Expression(Of Func(Of TEntity, Boolean))) As IEnumerable(Of TDto) Implements IService(Of TDto, TEntity).Find
			Return Me.Assembler.Assemble(Me.Repository.Find(filter))
		End Function
	
		Public Overridable Function Find(ByVal startRowIndex As Integer, ByVal maximumRows As Integer) As IEnumerable(Of TDto) Implements IService(Of TDto, TEntity).Find
			Return Me.Find(startRowIndex, maximumRows, Nothing, Nothing)
		End Function
	
		Public Overridable Function Find(ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of TDto) Implements IService(Of TDto, TEntity).Find
			Return Me.Find(Nothing, Nothing, sortExpression, filterExpression)
		End Function
	
		Public Overridable Function Find(ByVal startRowIndex? As Integer, ByVal maximumRows? As Integer, ByVal sortExpression As String, ByVal filterExpression As String) As IEnumerable(Of TDto) Implements IService(Of TDto, TEntity).Find
			Dim query As IQueryable(Of TEntity) = Me.Repository.GetAll()
	
			If Not String.IsNullOrEmpty(filterExpression) Then
				query = query.Where(filterExpression)
			End If
			If Not String.IsNullOrEmpty(sortExpression) Then
				query = query.OrderBy(sortExpression)
			End If
			If startRowIndex.HasValue Then
				query = query.Skip(startRowIndex.Value)
			End If
			If maximumRows.HasValue Then
				query = query.Take(maximumRows.Value)
			End If
	
			Return Me.Assembler.Assemble(query)
		End Function
	
		Public Overridable Function Count() As Integer Implements IService(Of TDto, TEntity).Count
			Return Me.Count(String.Empty)
		End Function
	
		Public Overridable Function Count(ByVal filterExpression As String) As Integer Implements IService(Of TDto, TEntity).Count
			Dim query As IQueryable(Of TEntity) = Me.Repository.GetAll()
	
			If Not String.IsNullOrEmpty(filterExpression) Then
				query = query.Where(filterExpression)
			End If
	
			Return query.Count()
		End Function
	
	
		Public Overridable Function GetByKey(ByVal _dtoKey As String) As TDto Implements IService(Of TDto, TEntity).GetByKey
			Dim key As ObjectKey = KeyUtility.Instance.Convert(Of TEntity)(_dtoKey)
			
			Return Me._assembler.Assemble(Me.Repository.Get(key))
		End Function
	
		Public Overridable Function Add(ByVal dto As TDto) As String Implements IService(Of TDto, TEntity).Add
			Dim entity As TEntity = Me._assembler.Assemble(Nothing, dto)
			
			Me._repository.Add(entity)
			Dim key As ObjectKey = KeyUtility.Instance.Create(entity)
	
			Return KeyUtility.Instance.Convert(key)
		End Function
	
		Public Overridable Sub Update(ByVal dto As TDto) Implements IService(Of TDto, TEntity).Update
			Dim key As ObjectKey = KeyUtility.Instance.Convert(Of TEntity)(dto.DtoKey)
			
			Dim entity As TEntity = Me._repository.Get(key)
	
			Me._assembler.Assemble(entity, dto)
		End Sub
	
		Public Overridable Sub Delete(ByVal dto As TDto) Implements IService(Of TDto, TEntity).Delete
			Dim key As ObjectKey = KeyUtility.Instance.Convert(Of TEntity)(dto.DtoKey)
			Dim entity As TEntity = Me._repository.Get(key)
	
			Me.Repository.Remove(entity)
		End Sub
	End Class
	
	Public Interface ITerritoryService
		Inherits IService(Of TerritoryDto, Territory)
	
	End Interface
	
	Partial Public Class TerritoryService
		Inherits Service(Of TerritoryDto, Territory)
		Implements ITerritoryService
		Public Sub New(ByVal assembler As ITerritoryAssembler, ByVal repository As ITerritoryRepository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
	
	Public Interface ISupplierService
		Inherits IService(Of SupplierDto, Supplier)
	
	End Interface
	
	Partial Public Class SupplierService
		Inherits Service(Of SupplierDto, Supplier)
		Implements ISupplierService
		Public Sub New(ByVal assembler As ISupplierAssembler, ByVal repository As ISupplierRepository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
	
	Public Interface IShipperService
		Inherits IService(Of ShipperDto, Shipper)
	
	End Interface
	
	Partial Public Class ShipperService
		Inherits Service(Of ShipperDto, Shipper)
		Implements IShipperService
		Public Sub New(ByVal assembler As IShipperAssembler, ByVal repository As IShipperRepository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
	
	Public Interface IRegionService
		Inherits IService(Of RegionDto, Region)
	
	End Interface
	
	Partial Public Class RegionService
		Inherits Service(Of RegionDto, Region)
		Implements IRegionService
		Public Sub New(ByVal assembler As IRegionAssembler, ByVal repository As IRegionRepository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
	
	Public Interface IProductService
		Inherits IService(Of ProductDto, Product)
	
	End Interface
	
	Partial Public Class ProductService
		Inherits Service(Of ProductDto, Product)
		Implements IProductService
		Public Sub New(ByVal assembler As IProductAssembler, ByVal repository As IProductRepository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
	
	Public Interface IOrderService
		Inherits IService(Of OrderDto, Order)
	
	End Interface
	
	Partial Public Class OrderService
		Inherits Service(Of OrderDto, Order)
		Implements IOrderService
		Public Sub New(ByVal assembler As IOrderAssembler, ByVal repository As IOrderRepository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
	
	Public Interface IOrderDetailService
		Inherits IService(Of OrderDetailDto, OrderDetail)
	
	End Interface
	
	Partial Public Class OrderDetailService
		Inherits Service(Of OrderDetailDto, OrderDetail)
		Implements IOrderDetailService
		Public Sub New(ByVal assembler As IOrderDetailAssembler, ByVal repository As IOrderDetailRepository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
	
	Public Interface IEmployeeService
		Inherits IService(Of EmployeeDto, Employee)
	
	End Interface
	
	Partial Public Class EmployeeService
		Inherits Service(Of EmployeeDto, Employee)
		Implements IEmployeeService
		Public Sub New(ByVal assembler As IEmployeeAssembler, ByVal repository As IEmployeeRepository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
	
	Public Interface IDomainClass1Service
		Inherits IService(Of DomainClass1Dto, DomainClass1)
	
	End Interface
	
	Partial Public Class DomainClass1Service
		Inherits Service(Of DomainClass1Dto, DomainClass1)
		Implements IDomainClass1Service
		Public Sub New(ByVal assembler As IDomainClass1Assembler, ByVal repository As IDomainClass1Repository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
	
	Public Interface ICustomerService
		Inherits IService(Of CustomerDto, Customer)
	
	End Interface
	
	Partial Public Class CustomerService
		Inherits Service(Of CustomerDto, Customer)
		Implements ICustomerService
		Public Sub New(ByVal assembler As ICustomerAssembler, ByVal repository As ICustomerRepository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
	
	Public Interface ICustomerDemographicService
		Inherits IService(Of CustomerDemographicDto, CustomerDemographic)
	
	End Interface
	
	Partial Public Class CustomerDemographicService
		Inherits Service(Of CustomerDemographicDto, CustomerDemographic)
		Implements ICustomerDemographicService
		Public Sub New(ByVal assembler As ICustomerDemographicAssembler, ByVal repository As ICustomerDemographicRepository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
	
	Public Interface ICategoryService
		Inherits IService(Of CategoryDto, Category)
	
	End Interface
	
	Partial Public Class CategoryService
		Inherits Service(Of CategoryDto, Category)
		Implements ICategoryService
		Public Sub New(ByVal assembler As ICategoryAssembler, ByVal repository As ICategoryRepository)
			MyBase.New(assembler, repository)
	
		End Sub
	End Class
End Namespace
